-------------------------------------------------------------------------------
-- onewire_0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library opb_onewire_v1_00_a;
use opb_onewire_v1_00_a.All;

entity onewire_0_wrapper is
  port (
    OPB_Clk : in std_logic;
    OPB_Rst : in std_logic;
    OPB_ABus : in std_logic_vector(0 to 31);
    OPB_BE : in std_logic_vector(0 to 3);
    OPB_RNW : in std_logic;
    OPB_select : in std_logic;
    OPB_seqAddr : in std_logic;
    OPB_DBus : in std_logic_vector(0 to 31);
    OW_DBus : out std_logic_vector(0 to 31);
    OW_errAck : out std_logic;
    OW_retry : out std_logic;
    OW_toutSup : out std_logic;
    OW_xferAck : out std_logic;
    ONEWIRE_DQ : inout std_logic
  );
  attribute x_core_info : STRING;
  attribute x_core_info of onewire_0_wrapper: entity is "opb_onewire_v1_00_a";

end onewire_0_wrapper;

architecture STRUCTURE of onewire_0_wrapper is

  component opb_onewire is
    generic (
      C_BASEADDR : std_logic_vector;
      C_HIGHADDR : std_logic_vector;
      C_OPB_DWIDTH : integer;
      C_OPB_AWIDTH : integer;
      CheckCRC : boolean;
      ADD_PULLUP : boolean;
      CLK_DIV : integer range 0 to 15
    );
    port (
      OPB_Clk : in std_logic;
      OPB_Rst : in std_logic;
      OPB_ABus : in std_logic_vector(0 to C_OPB_AWIDTH-1);
      OPB_BE : in std_logic_vector(0 to C_OPB_DWIDTH/8-1);
      OPB_RNW : in std_logic;
      OPB_select : in std_logic;
      OPB_seqAddr : in std_logic;
      OPB_DBus : in std_logic_vector(0 to C_OPB_DWIDTH-1);
      OW_DBus : out std_logic_vector(0 to C_OPB_DWIDTH-1);
      OW_errAck : out std_logic;
      OW_retry : out std_logic;
      OW_toutSup : out std_logic;
      OW_xferAck : out std_logic;
      ONEWIRE_DQ : inout std_logic
    );
  end component;

begin

  onewire_0 : opb_onewire
    generic map (
      C_BASEADDR => X"7a200000",
      C_HIGHADDR => X"7a20ffff",
      C_OPB_DWIDTH => 32,
      C_OPB_AWIDTH => 32,
      CheckCRC => true,
      ADD_PULLUP => true,
      CLK_DIV => 15
    )
    port map (
      OPB_Clk => OPB_Clk,
      OPB_Rst => OPB_Rst,
      OPB_ABus => OPB_ABus,
      OPB_BE => OPB_BE,
      OPB_RNW => OPB_RNW,
      OPB_select => OPB_select,
      OPB_seqAddr => OPB_seqAddr,
      OPB_DBus => OPB_DBus,
      OW_DBus => OW_DBus,
      OW_errAck => OW_errAck,
      OW_retry => OW_retry,
      OW_toutSup => OW_toutSup,
      OW_xferAck => OW_xferAck,
      ONEWIRE_DQ => ONEWIRE_DQ
    );

end architecture STRUCTURE;

